function leadingZero (num) {
  if (num < 10) { return '0' + num }
  else { return num.toString() }
}

var day = [
  'Sunday',
  'Monday',
  'Tuesday',
  'Wednesday',
  'Thursday',
  'Friday',
  'Saturday'
]

var month = [
  'January',
  'February',
  'March',
  'April',
  'May',
  'June',
  'July',
  'August',
  'September',
  'October',
  'November',
  'December'
]

export default {
  methods: {
    apiDate: function (date) {
      var d = new Date(date)
      return d.getFullYear() + '-' + leadingZero(d.getMonth() + 1) + '-' + leadingZero(d.getDate())
    },
    getWeekdayFromApiDate: function (date) {
      let d = new Date(date)
      let w = d.getDay()
      // Date.getDay() returns 0 for Sundays, but for our APIs we need 0 for Mondays
      if (w === 0) { return 6 }
      else { return w - 1 }
    },
    prettyDate: function (date) {
      var d = new Date(date)
      var dstring = ''
      dstring += day[d.getDay()] + ', '
      dstring += leadingZero(d.getDate()) + '. '
      dstring += month[d.getMonth()] + ' '
      dstring += d.getFullYear()
      return dstring
    },
    prettyDateTime: function (date) {
      var d = new Date(date)
      /*
      // This is a simple numbered representation - have to decide which one to use in final design
      // note: Date.getMonth() returns the month as an index from 0 to 11
      return leadingZero(d.getDate()) + '.' + leadingZero(d.getMonth() + 1) + '.' + d.getFullYear() + ' ' + leadingZero(d.getHours()) + ':' + leadingZero(d.getMinutes())
      */
      var dstring = ''
      dstring += day[d.getDay()] + ', '
      dstring += leadingZero(d.getDate()) + '. '
      dstring += month[d.getMonth()] + ' '
      dstring += d.getFullYear() + ', '
      dstring += leadingZero(d.getHours()) + ':' + leadingZero(d.getMinutes()) + ':' + leadingZero(d.getSeconds())
      return dstring
    },
    prettyHours(hours) {
      return hours.replace(/:00$/, '');
    },
    prettyDuration: function (start, end) {
      var seconds = (new Date(end).getTime() - new Date(start).getTime()) / 1000
      var minutes = Math.floor(seconds / 60)
      var duration = minutes + 'min'
      if (minutes < seconds / 60) {
        duration += ' '
        duration += seconds - 60 * minutes
        duration += 'sec'
      }
      return duration
    },
    prettyNanoseconds: function(ns) {
      var sec_total = ns / 1000 / 1000 / 1000
      var hours = Math.floor(sec_total / 3600)
      var minutes = Math.floor((sec_total - (hours * 3600)) / 60)
      var seconds = Math.floor((sec_total - (hours * 3600) - (minutes * 60)) * 10) / 10
      return hours + ':' + leadingZero(minutes) + ':' + leadingZero(seconds.toFixed(0))
    },
    nanosecondsToMinutes: function(ns) {
      return ns / 1000 / 1000 / 1000 / 60;
    },
    prettyWeekday: function(weekday) {
      return day[weekday];
    }
  }
}
